﻿-- Addon:	ChiBar: option panel
-- Author:	Rakhan(EU-Azshara)

if select(2, UnitClass("player")) ~= "MONK" then
    return
end


------------------------------------------
--		OptionsPanel					--
------------------------------------------

function ChiBar:createOptionsUI()
	ChiBar.opanel = CreateFrame("Frame", "ChiBarOptionsPanel", UIParent)
	ChiBar.opanel.name = "ChiBar";
	InterfaceOptions_AddCategory(ChiBar.opanel);

	-- Title
	ChiBar.Widgets = {}
	ChiBar.Widgets.title = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	ChiBar.Widgets.title:SetPoint("TOPLEFT", 16, -16)
	ChiBar.Widgets.title:SetText("|cff00FF96ChiBar Version 0.1 -- Rakhan(EU-Azshara)")
	
	-- MainSettingTitle
	ChiBar.Widgets.mainsettTitle = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	ChiBar.Widgets.mainsettTitle:SetPoint("TOPLEFT", 16, -70)
	ChiBar.Widgets.mainsettTitle:SetText(ChiBarLocalization.OP_MAINTITLE)
	
	-- EnableCheckBox
	ChiBar.Widgets.enableBox = CreateFrame("CheckButton", "EnableCheckBox", ChiBar.opanel, "OptionsBaseCheckButtonTemplate")
	ChiBar.Widgets.enableBox:SetPoint("TOPLEFT", ChiBar.Widgets.mainsettTitle, "BOTTOMLEFT", 0, -5)
	ChiBar.Widgets.enableBox:SetChecked(ChiBarDB.enable)
	ChiBar.Widgets.enableBox:SetScript("OnClick", ChiBar.enable)
	ChiBar.Widgets.enableText = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	ChiBar.Widgets.enableText:SetPoint("LEFT", ChiBar.Widgets.enableBox, "RIGHT", 10, 1)
	ChiBar.Widgets.enableText:SetText(ChiBarLocalization.OP_ENABLE)
	
	-- AutohideCheckBox
	ChiBar.Widgets.autohideBox = CreateFrame("CheckButton", "EnableCheckBox", ChiBar.opanel, "OptionsBaseCheckButtonTemplate")
	ChiBar.Widgets.autohideBox:SetPoint("TOPLEFT", ChiBar.Widgets.enableBox, "BOTTOMLEFT", 0, -1)
	ChiBar.Widgets.autohideBox:SetChecked(ChiBarDB.autohide)
	ChiBar.Widgets.autohideBox:SetScript("OnClick", ChiBar.autohide)
	ChiBar.Widgets.autohideText = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	ChiBar.Widgets.autohideText:SetPoint("LEFT", ChiBar.Widgets.autohideBox, "RIGHT", 10, 1)
	ChiBar.Widgets.autohideText:SetText(ChiBarLocalization.OP_AUTOHIDE)

	-- ScaleTitle
	ChiBar.Widgets.scaleTitle = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	ChiBar.Widgets.scaleTitle:SetPoint("TOPLEFT", ChiBar.Widgets.autohideBox, "BOTTOMLEFT", 0, -10)
	ChiBar.Widgets.scaleTitle:SetText(ChiBarLocalization.OP_SCALETITLE)

	-- ScaleSlider
	ChiBar.Widgets.scaleSlider = CreateFrame('Slider', 'ScaleSlider', ChiBar.opanel, 'OptionsSliderTemplate')
	ChiBar.Widgets.scaleSlider:SetPoint("TOPLEFT", ChiBar.Widgets.scaleTitle, "BOTTOMLEFT", 0, -10)
	ChiBar.Widgets.scaleSlider:SetMinMaxValues(0.1, 2)
	ChiBar.Widgets.scaleSlider:SetValue(ChiBarDB.scale)
	getglobal(ChiBar.Widgets.scaleSlider:GetName() .. 'Low'):SetText('0.1');
	getglobal(ChiBar.Widgets.scaleSlider:GetName() .. 'High'):SetText('2');
	ChiBar.Widgets.scaleSlider:SetScript("OnValueChanged", ChiBar.scaleUI)
	ChiBar.Widgets.currScaleText = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	ChiBar.Widgets.currScaleText:SetPoint("LEFT", ChiBar.Widgets.scaleSlider, "RIGHT", 25, 0)
	ChiBar.Widgets.currScaleText:SetText(ChiBarDB.scale)
	
	--DropboxTitle
	ChiBar.Widgets.dropdownTitle = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	ChiBar.Widgets.dropdownTitle:SetPoint("TOPLEFT", ChiBar.Widgets.scaleSlider, "BOTTOMLEFT", 0, -25)
	ChiBar.Widgets.dropdownTitle:SetText(ChiBarLocalization.OP_DROPBOXTITLE)
	
	-- TextureDropDown
	ChiBar.Widgets.dropdownMenu = CreateFrame("Frame", "DropdownMenu", ChiBar.opanel, "UIDropDownMenuTemplate")
	ChiBar.Widgets.dropdownMenu:SetPoint("TOPLEFT", ChiBar.Widgets.dropdownTitle, "BOTTOMLEFT", 0, -10)
	ChiBar.Widgets.dropdownItems = {"Ying & Yang", "Minimalistic", "Chinese Dragon",}
	local function OnClick(self)
		UIDropDownMenu_SetSelectedID(ChiBar.Widgets.dropdownMenu, self:GetID())
		ChiBarDB.savedTexture = self:GetID()
		ChiBar:changeTexture()
	end
	local function initialize(self, level)
		local info = UIDropDownMenu_CreateInfo()
		for k, v in pairs(ChiBar.Widgets.dropdownItems) do
			info = UIDropDownMenu_CreateInfo()
			info.text = v
			info.value = v
			info.func = OnClick
			UIDropDownMenu_AddButton(info, level)
		end
	end
	UIDropDownMenu_Initialize(ChiBar.Widgets.dropdownMenu, initialize)
	UIDropDownMenu_SetWidth(ChiBar.Widgets.dropdownMenu, 100);
	UIDropDownMenu_SetButtonWidth(ChiBar.Widgets.dropdownMenu, 124)
	UIDropDownMenu_SetSelectedID(ChiBar.Widgets.dropdownMenu, 1)
	UIDropDownMenu_JustifyText(ChiBar.Widgets.dropdownMenu, "LEFT")
	UIDropDownMenu_SetSelectedID(ChiBar.Widgets.dropdownMenu, ChiBarDB.savedTexture)

	
	-- LockButton
	ChiBar.Widgets.lockButton = CreateFrame("Button", "LockButton", ChiBar.opanel, "GameMenuButtonTemplate")
	ChiBar.Widgets.lockButton:SetHeight(25)
	ChiBar.Widgets.lockButton:SetWidth(100)
	ChiBar.Widgets.lockButton:SetPoint("TOPLEFT", ChiBar.Widgets.dropdownMenu, "BOTTOMLEFT", 0, -10)
	ChiBar.Widgets.lockButton:SetText(ChiBarLocalization.OP_LOCKBTN1)
	ChiBar.Widgets.lockButton:SetScript("OnClick", ChiBar.lockFrame)
	
	-- ResetButton
	ChiBar.Widgets.resetButton = CreateFrame("Button", "ResetButton", ChiBar.opanel, "GameMenuButtonTemplate")
	ChiBar.Widgets.resetButton:SetHeight(25)
	ChiBar.Widgets.resetButton:SetWidth(100)
	ChiBar.Widgets.resetButton:SetPoint("TOPLEFT", ChiBar.Widgets.lockButton, "BOTTOMLEFT", 0, -5)
	ChiBar.Widgets.resetButton:SetText(ChiBarLocalization.OP_RESET)
	ChiBar.Widgets.resetButton:SetScript("OnClick", ChiBar.reset)
end

-- PopUpHandling for Unlocking
StaticPopupDialogs["CHIBAR_UNLOCKFRAME"] = {
  text = ChiBarLocalization.OP_UNLOCKTEXT,
  button1 = ChiBarLocalization.OP_LOCKBTN2,
  OnAccept = function()
      ChiBar:lockFrame()
	  InterfaceOptionsFrame_OpenToCategory(ChiBar.opanel)
  end,
  OnCancel = function()
      ChiBar:lockFrame()
	  InterfaceOptionsFrame_OpenToCategory(ChiBar.opanel)
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,  -- avoid some UI taint, see http://www.wowace.com/announcements/how-to-avoid-some-ui-taint/
}

------------------------------------------
--		End of Script					--
------------------------------------------